<?php

namespace LewisLarsen\Ebay\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RefundLineType StructType
 * Meta information extracted from the WSDL
 * - documentation: This type is deprecated.
 * @subpackage Structs
 */
class RefundLineType extends AmountType
{
    /**
     * The _
     * @var \LewisLarsen\Ebay\StructType\AmountType
     */
    public $_;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - documentation: This field is deprecated.
     * @var string
     */
    public $type;
    /**
     * Constructor method for RefundLineType
     * @uses RefundLineType::set_()
     * @uses RefundLineType::setType()
     * @param \LewisLarsen\Ebay\StructType\AmountType $_
     * @param string $type
     */
    public function __construct(\LewisLarsen\Ebay\StructType\AmountType $_ = null, $type = null)
    {
        $this
            ->set_($_)
            ->setType($type);
    }
    /**
     * Get _ value
     * @return \LewisLarsen\Ebay\StructType\AmountType|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param \LewisLarsen\Ebay\StructType\AmountType $_
     * @return \LewisLarsen\Ebay\StructType\RefundLineType
     */
    public function set_(\LewisLarsen\Ebay\StructType\AmountType $_ = null)
    {
        $this->_ = $_;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @uses \LewisLarsen\Ebay\EnumType\RefundLineTypeCodeType::valueIsValid()
     * @uses \LewisLarsen\Ebay\EnumType\RefundLineTypeCodeType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \LewisLarsen\Ebay\StructType\RefundLineType
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\LewisLarsen\Ebay\EnumType\RefundLineTypeCodeType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \LewisLarsen\Ebay\EnumType\RefundLineTypeCodeType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \LewisLarsen\Ebay\EnumType\RefundLineTypeCodeType::getValidValues())), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
}
